#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <stdio.h>
#include <pthread.h>
#include <string.h>

#include "Communication_tcp.h"

/*Fonction permettant d'envoyer un message TCP sur le socket mis en argument */
int envoie_message(char* message,int socket)
{
    if(send(socket, message, strlen(message), 0) < 0)
    {
        perror("send()");
        return -1;
    }
    return 0;
}

/*Permet de récupérer les messages TCP qui sont envoyés sur le socket entré en argument */
char* reception_message(char* message,int socket){
    char *buffer;
    buffer = (char *)malloc(sizeof(char)*1024);
    int n = 0;
    
    if((n = recv(socket, buffer, sizeof buffer - 1, 0)) < 0)
    {
        perror("recv()");
        exit(-1);
    }
    
    buffer[n] = '\0';
    return buffer;
}

/*Permet de dire au serveur qui vient de se connecter, afin que le serveur puisse gérer le plus facilement les différents clients et leurs demandes*/
void Identification_serveur(int socket, char* pseudo){
    char *message;
    message = (char *)malloc(sizeof(char)*(TAILLE_PSEUDO+30));
    printf("Quel est votre pseudo?");
    scanf("%s",pseudo);
    int n = sprintf(message,"Init_Pseudo!: %s\n",pseudo); //ajout de la trame de commande serveur
    if(n < 0){
        printf("[client] [Communication_tcp.c] [Identification_serveur] sprintf fail\n");
        exit(EXIT_FAILURE);
    }
    message[n] = '\0';
    envoie_message(message,socket);
    free(message);
}
