#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <stdio.h>
#include <pthread.h>
#include <string.h>
#include <arpa/inet.h>

#include "Communication_udp.h"


/*Fonction permettant d'envoyer un message UDP sur le socket mis en argument */
int envoie_message_udp(char* message,int s,int taille, struct sockaddr_in serveur)
{
    /* Envoi du message */
    char* msg = malloc(sizeof(char)*taille);
    strcpy(msg,message);
    socklen_t len=sizeof(serveur);
#ifdef DEBUG
    printf("[Communication_udp.c] [envoie_message_udp] Socket : '%d', messsage : '%s', IP: '%s', port : '%d'\n",s,msg, inet_ntoa(serveur.sin_addr),ntohs(serveur.sin_port));
#endif
    int nboctets=sendto(s,msg,taille,0,(struct sockaddr*) &serveur,len);
    free(msg);
    if(nboctets<0){ 
        perror("messageUDPgenerique.sento"); 
        return -1; 
    }
    return 1;
}

/*Permet de récupérer les messages UDP qui sont envoyés sur le socket entré en argument */
int reception_message_udp(char* buffer,int socket){
    struct sockaddr_in *addr = malloc(sizeof(struct sockaddr_in));
    socklen_t lenaddr = sizeof(addr);
    int n = recvfrom(socket, buffer,100 , MSG_DONTWAIT, (struct sockaddr*) addr,&lenaddr);
    if(n < 0)
    {
        return 0;
        //exit(-1);
    }
    
    buffer[n] = '\0';
    
#ifdef DEBUG
    printf("[Communication_udp.c] [reception_message_udp] Taille du message recu : '%d' socket : '%d', messsage recu : '%s', addresse : '%s', port : '%d'\n",n,socket,buffer,inet_ntoa(addr->sin_addr),ntohs(addr->sin_port));
#endif
    free(addr);
    
    return 1;
}

/*Permet de dire au serveur qui vient de se connecter, afin que le serveur puisse gérer facilement les différents clients et leurs demandes*/
void Identification_serveur_udp(int socket,struct sockaddr_in serveur, char* pseudo){
    char *message;
    message = (char *)malloc(sizeof(char)*(TAILLE_PSEUDO+30));
    printf("Quel est votre pseudo?");
    scanf("%s",pseudo);
    int n = sprintf(message,"Init_Pseudo!: %s\n",pseudo);
    if(n < 0){
        printf("[client] [Communication_udp.c] [Identification_serveur_udp] sprintf fail\n");
        exit(EXIT_FAILURE);
    }
    message[n] = '\0';
    envoie_message_udp(message,socket,strlen(message), serveur);
    free(message);
}
