#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <stdio.h>
#include <pthread.h>
#include <string.h>
#include <poll.h>
#include <arpa/inet.h>    
#include <sys/time.h>
#include <netinet/tcp.h>

#include "Hole_punching.h"
#include "Connexion_client_tcp.h"

#define TAILLE_PSEUDO 40
#define MAX_TAMPON 100

static int client_verifier;
extern int demande_de_connexion_HP_TCP;

struct information_hole_punching_TCP{
    int socket_serveur_P2P;
    struct sockaddr_in addr_voulu;
};

/*Décrypte le message du serveur servant à la connexion au peer puis lance les fonctions de communication*/
void hole_punching(char * message, int socket){
    
#ifdef DEBUG
    printf("[client] [Hole_punching.c] [hole_punching_udp] Demande de hole punching du serveur avec le message : '%s'\n",message);
#endif
    
    char *chaine = NULL;
    chaine = strchr(message,' ');
    char* client_B = malloc(sizeof(char)*TAILLE_PSEUDO);
    int i = 1;
    while(chaine[i] != '\n'){   //Récupération du login que le serveur a envoyé
        client_B[i-1] = chaine[i];
        i++;
    }
        
    client_B[i-1] = '\0';
    chaine[0] = 'a';

#ifdef DEBUG
        printf("[client] [Hole_punching.c] [hole_punching_udp] Login du peer avec qui nous allons initier la connexion '%s'\n message restant a traiter chaine : '%s' et message : '%s'\n",client_B,chaine, message);
#endif

    chaine = strchr(message,' ');
    char* IP_client_B = malloc(sizeof(char)*25);
    i = 1;
    while(chaine[i] != '\n'){   //Récupération de l'IP que le serveur a envoyé
        IP_client_B[i-1] = chaine[i];
        i++;
    }
    IP_client_B[i-1] = '\0';
    chaine[0] = 'a';

#ifdef DEBUG
        printf("[client] [Hole_punching.c] [hole_punching_udp] IP du peer avec qui nous allons initier la connexion '%s'\n message restant a traiter chaine : '%s' et message : '%s'\n",IP_client_B,chaine, message);
#endif

    
    
    chaine = strchr(message,' ');
    char* port_client_B = malloc(sizeof(char)*5);
    i = 1;
    int port = 0;
    while(chaine[i] != '\n'){   //Récupération du port que le serveur a envoyé
        port_client_B[i-1] = chaine[i];
        i++;
    }
    port_client_B[i-1] = '\0';

#ifdef DEBUG
        printf("[client] [Hole_punching.c] [hole_punching_udp] Port du peer avec qui nous allons initier la connexion '%s'\n message restant chaine : '%s' et message : '%s'\n",port_client_B,chaine, message);
#endif

    i = 0;
    while(port_client_B[i] >=48 && port_client_B[i] <=57 ){
        port =port*10 +( (short int ) port_client_B[i]-48);
        i++;
    }

#ifdef DEBUG
        printf("[client] [Hole_punching.c] [hole_punching_udp] Port client B en int : '%d'\n",port);
#endif

    
    struct sockaddr_in addr_client_B;
    
    addr_client_B.sin_family = AF_INET; 
    addr_client_B.sin_port = htons(port);
    inet_aton(IP_client_B, &addr_client_B.sin_addr);

#ifdef DEBUG
        printf("[client] [Hole_punching.c] [hole_punching_udp] Informations du peer avec qui nous allons initier la connexion, son IP : '%s' et son port : '%d'\n" ,inet_ntoa(addr_client_B.sin_addr),ntohs(addr_client_B.sin_port));
#endif
    int statut = connexion_hole_punching_TCP(addr_client_B,socket);
    if(statut == -1){
        printf("Connexion à %s a échoué\n",client_B);
        return;
    }
}    
    
int connexion_hole_punching_TCP( struct sockaddr_in addr, int socket){

#ifdef DEBUG
    printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Tentative de connexion au peer d'IP : '%s' et son port : '%d'\n",inet_ntoa(addr.sin_addr),ntohs(addr.sin_port) );
#endif
        
    struct sockaddr_in *addr_utilise_avec_le_serveur = malloc(sizeof(struct sockaddr_in));
    socklen_t len_serv = sizeof(addr_utilise_avec_le_serveur);
    getsockname(socket, (struct sockaddr*) addr_utilise_avec_le_serveur, &len_serv);
    int socket_serveur_P2P = Initialisation_serveur_P2P(*addr_utilise_avec_le_serveur);
        
#ifdef DEBUG
    printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Nos informations de connexion : IP : '%s' et port : '%d'\n", inet_ntoa((*addr_utilise_avec_le_serveur).sin_addr),ntohs(addr_utilise_avec_le_serveur->sin_port));
#endif
    
    
#ifdef DEBUG
    printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] socket_serveur_P2P : '%d'\n",socket_serveur_P2P);
#endif
    
    pthread_t pid;
    struct information_hole_punching_TCP *peerB = malloc(sizeof(struct information_hole_punching_TCP));
    peerB->socket_serveur_P2P = socket_serveur_P2P;
    peerB->addr_voulu = addr;
    /*Si nous avons initié la connexion P2P, le thread se lance*/
    if(demande_de_connexion_HP_TCP == 1){
        pthread_create(&pid,NULL,Serveur_P2P,(void*) peerB);  
        pthread_join(pid,NULL);
    }
    else{
        /*Sinon le client essaie de se connecter en permanence*/
        struct sockaddr_in* addr_serveur_connecte = malloc(sizeof(struct sockaddr_in));
        socklen_t len_serveur_connecte = sizeof(addr_serveur_connecte);
        int i = 0;
        int socket_peer;
        client_verifier = 0;
        int connexion_au_serveur_P2P = 0;
    
        while(!client_verifier){
            socket_peer = connexion_serveur(ntohs(addr.sin_port), inet_ntoa(addr.sin_addr));
#ifdef DEBUG
            printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Tour : '%d'\n", i++);
#endif
        
            if(socket_peer == -1){
                perror("client.hole_punching.connexion_hole_punching_TCP.connect");
            }
            else{
            
                getpeername(socket_peer,(struct sockaddr *) addr_serveur_connecte,&len_serveur_connecte);
            
#ifdef DEBUG
                printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Connexion au serveur dont les infos sont : IP : '%s' et port : '%d', nous voulons le serveur avec l'@ IP : '%s' \n", inet_ntoa(addr_serveur_connecte->sin_addr), ntohs(addr_serveur_connecte->sin_port), inet_ntoa((*peerB).addr_voulu.sin_addr));
#endif
                if(strcmp(inet_ntoa(addr_serveur_connecte->sin_addr), inet_ntoa(peerB->addr_voulu.sin_addr)) == 0){
                    client_verifier = 1;
#ifdef DEBUG
                    printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Connexion avec le peer établie\n");
#endif
            
                    connexion_au_serveur_P2P = 1;
                    free(peerB);
                    int result = 0;
#ifdef DEBUG
                    printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Fin forcée du thread avec retour : %d\n", (int) result);
#endif
                    break;
                }
                else{
                    close(socket_peer);
                    socket_peer = -1;
#ifdef DEBUG
                    printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Le client s'est connecté à un serveur non souhaité\n");
#endif
                }
            }
#ifdef DEBUG
            printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Début sleep\n");
#endif
            sleep(1);
#ifdef DEBUG
            printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Fin sleep\n");
#endif
        
        }
        if(connexion_au_serveur_P2P == 0){
        
#ifdef DEBUG
            printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Attend la fin du thread du Serveur_P2P\n");
#endif
        }
        else{
            Discussion_P2P(socket_peer);
        }
    }
    return 0;
}

/*Serveur attendant la connexion du peer tout en vérifiant si c'est le peer souhaité*/
void * Serveur_P2P(void* arg){
    struct information_hole_punching_TCP *TCP = (struct information_hole_punching_TCP*) arg;
    struct sockaddr_in *addr_client_connecte = malloc(sizeof(struct sockaddr_in));
    socklen_t len_client_connecte = sizeof(addr_client_connecte);
    int socket_peer = -1;
    while(!client_verifier){
        socket_peer=accept(TCP->socket_serveur_P2P,(struct sockaddr *) addr_client_connecte, &len_client_connecte);
#ifdef DEBUG
        static int tour = 0;
        printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Tour : '%d'\n", tour++);
#endif
        if(socket_peer<0){
            
            perror("client.hole_punching.connexion_hole_punching_TCP.accept");
            int statut_end = -1;
            pthread_exit((void*) &statut_end); //vérifie que la fonction ne renvoie pas d'erreur et récupère les informations nécessaires du client
        }
        getpeername(socket_peer,(struct sockaddr *) addr_client_connecte,&len_client_connecte);
        
#ifdef DEBUG
        printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Arrivé d'un client dans le thread Serveur_P2P avec les infos suivantes : IP : '%s' et port : '%d', nous voulons le client avec les infos suivantes : IP : '%s' et le port '%d'\n",inet_ntoa(addr_client_connecte->sin_addr), ntohs(addr_client_connecte->sin_port), inet_ntoa((*TCP).addr_voulu.sin_addr), ntohs(TCP->addr_voulu.sin_port));
#endif
        if(strcmp(inet_ntoa(addr_client_connecte->sin_addr), inet_ntoa(TCP->addr_voulu.sin_addr)) == 0 ){//&& addr_client_connecte->sin_port == peerB->addr_voulu.sin_port){
            client_verifier = 1;
#ifdef DEBUG
            printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Le client vient d'être identifié par le serveur\n");
#endif
        }
        else{
            close(socket_peer);
#ifdef DEBUG
            printf("[client] [Hole_punching.c] [connexion_hole_punching_TCP] Un client vient d'être identifié par le serveur mais a dû être déconnectée car ce n'est pas le client souhaité pour la connexion P2P\n");
#endif
        }
    }
    free(addr_client_connecte);
    free(arg);
    Discussion_P2P(socket_peer);
    pthread_exit((void *)&socket_peer);
}

/*Permet la communication avec le peer*/
void Discussion_P2P(int socket){
    
#ifdef DEBUG
    printf("[client] [Hole_punching.c] [Discussion_P2P] Début de la Discussion_P2P sur le socket : '%d'\n",socket);
#endif
    struct sockaddr_in *addr_client_connecte = malloc(sizeof(struct sockaddr_in));
    socklen_t len_client_connecte = sizeof(addr_client_connecte);
    getpeername(socket,(struct sockaddr *) addr_client_connecte,&len_client_connecte);
    printf("[client] [Hole_punching.c] [Discussion_P2P] Discussion en peer to peer avec le correspondant ayant les informations suivantes : IP : '%s' et port : '%d' sur la socket '%d' \n",inet_ntoa(addr_client_connecte->sin_addr), ntohs(addr_client_connecte->sin_port), socket);
    
    /* Boucle de communication avec le peer */
    struct pollfd descripteurs_P2P_TCP[2];
    descripteurs_P2P_TCP[0].fd=socket;       //fd du peer
    descripteurs_P2P_TCP[0].events=POLLIN;
    descripteurs_P2P_TCP[1].fd=0;       //fd=0 signifie provenant du même terminal
    descripteurs_P2P_TCP[1].events=POLLIN;
    
    /*Permet l'envoi et la réception des messages avec le serveur le plus facilement et le plus rapidement possible */
    int Com_P2P_on = 1;
    while(Com_P2P_on){
        int nb=poll(descripteurs_P2P_TCP,2,-1);
        char* tampon = (char *) malloc(sizeof(char )*MAX_TAMPON);
        if(nb<0){ perror("main.poll"); exit(EXIT_FAILURE); }
                    
#ifdef DEBUG
        printf("[client] [Hole_punching.c] [Discussion_P2P] poll détection de changement \n");
#endif
        /* Regarde si le peer a envoyé un message pour l'afficher sur le terminal à travers la variable tampon */
        if((descripteurs_P2P_TCP[0].revents&POLLIN)!=0){
            int taille=read(socket,tampon,MAX_TAMPON);
            if(taille<=0) {
                printf("[client] [Hole_punching.c] [Discussion_P2P] Problème réception du message en provenance du serveur\n");
                free(tampon);
                break;
            }
            
#ifdef DEBUG
            printf("[client] [Hole_punching.c] [Discussion_P2P] Message reçu du peer avant gestion_requete_peer : '%s'\n",tampon);
#endif
            tampon[taille] = '\0';
            int requete_peer = gestion_requete_peer(tampon);
            if( requete_peer == 1){
                printf("[client] [Hole_punching.c] [Discussion_P2P] Réception d'un message du peer :");
                int data = write(1,tampon,taille);
                if(data <0){
                    printf("[client] [Hole_punching.c] [Discussion_P2P] Problème d'envoi du message vers le terminal\n");
                    free(tampon);
                    break;
                }
            }
            else{
#ifdef DEBUG
                printf("[client] [Hole_punching.c] [Discussion_P2P] Deconnexion du peer\n");
#endif
                Com_P2P_on = 0;
            }
        }
        
        /* Regarde si un message est rentré dans la console pour pouvoir l'envoyer au serveur */
        if((descripteurs_P2P_TCP[1].revents&POLLIN)!=0){
            int taille=read(0,tampon,MAX_TAMPON);
            if(taille<=0){
                printf("[client] [Hole_punching.c] [Discussion_P2P] Problème d'envoi du message au serveur\n");
                break;
            }
            tampon[taille] = '\0';
            int requete_client = gestion_requete_peer(tampon);
            if(requete_client == -1){
#ifdef DEBUG
                printf("[client] [Hole_punching.c] [Discussion_P2P] Message de déconnexion envoyé au peer: '%s'\n",tampon);
#endif
                int data = write(socket,tampon,taille);
                if(data <0){
                    printf("[client] [Hole_punching.c] [Discussion_P2P] Problème d'envoi du message au serveur\n");
                    break;
                }
                Com_P2P_on = 0;
            }
            else if(requete_client == 1){
                int data = write(socket,tampon,taille);      
                if(data <0){
                    printf("[client] [Hole_punching.c] [Discussion_P2P] Problème d'envoi du message au serveur\n");
                    break;
                }
#ifdef DEBUG
                printf("[client] [Hole_punching.c] [Discussion_P2P] Message envoyé au peer: '%s'\n",tampon);
#endif
        
            }
                
        }
        free(tampon);
    }
    
    /* On termine la connexion */
    shutdown(socket,SHUT_RDWR);
    close(socket);
}

int gestion_requete_peer(char* msg){
    if(strcmp(msg,"exit\n") == 0){
        return -1;
    }
    return 1;
}

int Initialisation_serveur_P2P(struct sockaddr_in adresse)
{
#ifdef DEBUG
    printf("[client] [Hole_punching.c] [Initialisation_serveur_P2P] Début de la creation de la socket peer to peer avec les informations suivantes : IP : '%s' et port : '%d'\n", inet_ntoa(adresse.sin_addr),ntohs(adresse.sin_port) );
#endif
    int s;
    socklen_t taille= sizeof(adresse);
    int statut;
    
    /* Creation d'une socket */
    s=socket(PF_INET,SOCK_STREAM,0);
    if(s<0){
        perror("Initialisation_serveur_P2P.socket");
        exit(-1);
    }
    
    /*Set les options de TIMEOUT et de REUSE pour permettre la connexion hole punching*/
    int vrai =1;
    if(setsockopt(s,SOL_TCP,TCP_NODELAY,&vrai,sizeof(vrai))<0){
        perror("Initialisation_serveur_P2P.setsockopt (REUSEPORT)");
        exit(-1);
    }
    if(setsockopt(s,SOL_SOCKET,SO_REUSEADDR,&vrai,sizeof(vrai))<0){
        perror("Initialisation_serveur_P2P.setsockopt (REUSEADDR)");
        exit(-1);
    }
    if(setsockopt(s,SOL_SOCKET,SO_REUSEPORT,&vrai,sizeof(vrai))<0){
        perror("Initialisation_serveur_P2P.setsockopt (REUSEPORT)");
        exit(-1);
    }
    /* Spécification de l'adresse de la socket */
    statut=bind(s,(struct sockaddr *)&adresse,sizeof(adresse));
    if(statut<0){
        perror("Initialisation_serveur_P2P.bind");
        return -1;
    }
    /* On récupère le numéro du port utilisé */
    statut=getsockname(s,(struct sockaddr *)&adresse,&taille);
    if(statut<0){
        perror("Initialisation_serveur_P2P.getsockname");
        exit(-1);
    }
    
    
    /* Taille de la queue d'attente */
    statut=listen(s,10);
    if(statut<0){
        perror("Initialisation_serveur_P2P.listen");
        return -1;
    }
    
#ifdef DEBUG
    printf("[client] [Hole_punching.c] [Initialisation_serveur_P2P] Création de la socket peer to peer avec les informations suivantes : socket : '%d' IP : '%s' et port : '%d'\n", s, inet_ntoa(adresse.sin_addr),ntohs(adresse.sin_port) );
#endif
    return s;
}
