#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <stdio.h>
#include <pthread.h>
#include <string.h>
#include <arpa/inet.h>

#include "Communication_udp_6.h"

#define TAILLE_PSEUDO 40

/*Fonction permettant d'envoyer un message sur la socket mis en argument */
int envoie_message_udp(char* message,int s,int taille, struct sockaddr_in6 serveur)
{
    /* Envoi du message */
    char* msg = malloc(sizeof(char)*taille);
    strcpy(msg,message);
    socklen_t len=sizeof(serveur);
    char *str=malloc(sizeof(char)*INET6_ADDRSTRLEN);
    memset(str,0,sizeof(char)*INET6_ADDRSTRLEN);
    inet_ntop(AF_INET6, &(serveur.sin6_addr), str, sizeof(char)*INET6_ADDRSTRLEN);
#ifdef DEBUG
    printf("[Communication_udp_6.c] [envoie_message_udp] socket : '%d', messsage : '%s', IP: '%s', port : '%d'\n",s,msg, str,ntohs(serveur.sin6_port));
#endif
    int nboctets=sendto(s,msg,taille,0,(struct sockaddr *)&serveur,len);
    free(msg);
    free(str);
    if(nboctets<0){ 
        perror("messageUDPgenerique.sento"); 
        return -1; 
    }
    return 1;
}

/*Permet de récupérer les messages qui sont envoyés sur la socket entrée en argument */
int reception_message_udp(char* buffer,int socket){
    struct sockaddr_in6 *addr = malloc(sizeof(struct sockaddr_in6));
    socklen_t lenaddr = sizeof(addr);
    int n = recvfrom(socket, buffer,100 , MSG_DONTWAIT, (struct sockaddr*) addr,&lenaddr);
    if(n < 0)
    {
        return 0;
        //exit(-1);
    }
    
    buffer[n] = '\0';
    char *str=malloc(sizeof(char)*INET6_ADDRSTRLEN);
    memset(str,0,sizeof(char)*INET6_ADDRSTRLEN);
    inet_ntop(AF_INET6, &(addr->sin6_addr), str, sizeof(char)*INET6_ADDRSTRLEN);
#ifdef DEBUG
    printf("[Communication_udp_6.c] [reception_message_udp] Taille du message recu : '%d' socket : '%d', messsage recu : '%s', addresse : '%s', port : '%d'\n",n,socket,buffer,str,ntohs(addr->sin6_port));
#endif
    free(addr);
    free(str);
    return 1;
}

/*Permet d'indiquer au serveur qui vient de se connecter, afin qu'il puisse gérer facilement les différents clients */
void Identification_serveur_udp(int socket,struct sockaddr_in6 serveur, char* pseudo){
    char *message;
    message = (char *)malloc(sizeof(char)*(TAILLE_PSEUDO+30));
    printf("Quel est votre pseudo?");
    scanf("%s",pseudo);
    int n = sprintf(message,"Init_Pseudo!: %s\n",pseudo);
    if(n < 0){
        printf("[client] [Communication_udp_6.c] [Identification_serveur_udp] sprintf fail\n");
        exit(EXIT_FAILURE);
    }
    message[n] = '\0';
    envoie_message_udp(message,socket,strlen(message), serveur);
    free(message);
}
