#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <netinet/in.h>
#include <poll.h>
#include <getopt.h>
#include <string.h>      
#include <arpa/inet.h>

#include "Communication_udp_6.h"
#include "Connexion_client_udp_6.h"

#define DEFAULT_PORT 2020
#define IPV4_SIZE 4

/*s est la fonction sigint_recu permettant la fermeture du socket en cas de signal SIGINT recu par le serveur */
static int s;
static int etat_tcp_udp; //variable pour connaître le protocole utilisé lors du sigint



void Mauvais_argument(){
    printf("Les arguments entrés sont erronés, voici les commandes possibles : \n-t ou --TCP (pour lancer le client en TCP)\n-u ou --UDP (pour lancer le client en UDP)\n-p <port> --port <port> (pour choisir le port de connexion au serveur)\n-a ou --adresse (pour définir l'adresse du serveur)\nPar défaut le client est lancé en UDP à l'adresse 2a03:75c0:21:23e::1 sur le port 2020\n");
}

int analyse_syntaxe(int argc, char **argv,short int *service,char* adresse){
    int c;
    int sortie = 2;
    while (1) {
        int option_index = 0;
        static struct option long_options[] = {
            {"adresse",     required_argument, 0,  'a' },
            {"port",     required_argument, 0,  'p' },
            {"TCP",     no_argument, 0,  't' },
            {"UDP",     no_argument, 0,  'u' },
        };
        c = getopt_long(argc, argv, "tup:a:",long_options, &option_index);
        if (c == -1) break;
        
        int i = 0;
        short int port = 0;
        switch (c) {
            case 0:
                printf("option %s", long_options[option_index].name);
                if (optarg)
                    printf(" with arg %s", optarg);
                printf("\n");
                break;
                
            case 'p':
                while(optarg[i] >=48 && optarg[i] <=57 ){
                    port =port*10 +( (short int ) optarg[i]-48);
                    i++;
                }
                *service = port;
                break;
            
            case 't':
                sortie = 1;
                break;
                
            case 'u':
                sortie = 2;
                break;
                
            case 'a':
                strcpy(adresse,optarg);
                break;
            default:
                printf("?? getopt returned character code 0%o ??\n", c);
        }
    }
    if (optind < argc) {
        sortie = 0;
        Mauvais_argument();
    }
    return sortie;
}

void sigint_recu(int sig)
{
    printf("SIGINT impossible, pour se déconnecter du peer taper exit, pour se déconnecter du serveur taper 2\n");
}

int main(int argc,char *argv[]){
    
    struct sigaction action;
    action.sa_handler = sigint_recu;
    action.sa_flags = SA_RESTART;
    sigaction(SIGINT, &action, NULL);
    
    short int service = DEFAULT_PORT;
    char* adresse = malloc(sizeof (char)*INET6_ADDRSTRLEN);
    sprintf(adresse,"2a03:75c0:21:23e::1"); 

    int statut = analyse_syntaxe(argc,argv,&service,adresse);
    
//     if(statut == 1){
//         printf("Client TCP vers serveur %s au port : %d\n",adresse,service);
//         etat_tcp_udp=0;
//         ClientTCP(adresse, service,s);
//     }
    
    if(statut == 2){
        printf("Client UDP vers serveur %s au port : %d\n",adresse,service);
        etat_tcp_udp=1;
        ClientUDP(adresse, service,s);
    }
    
    
    
    return 0;
}
