

#include "Lancement_Serveur_TCP.h"


/*Ouverture du serveur sur le port "port". Renvoie le file descriptor de la socket du serveur */
int initialisationServeur_TCP(short int *port,int connexions)
{
    int s;
    struct sockaddr_in adresse;
    socklen_t taille=sizeof adresse;
    int statut;
    
    /* Création d'une socket */
    s=socket(PF_INET,SOCK_STREAM,0);
    if(s<0){
        perror("initialisationServeur.socket");
        exit(-1);
    }
    int vrai =1;
    if(setsockopt(s,SOL_SOCKET,SO_REUSEADDR,&vrai,sizeof(vrai))<0){
        perror("initialisationServeur.setsockopt (REUSEADDR)");
        exit(-1);
    }
    if(setsockopt(s,SOL_SOCKET,SO_REUSEPORT,&vrai,sizeof(vrai))<0){
        perror("initialisationServeur.setsockopt (REUSEADDR)");
        exit(-1);
    }
    /* Spécification de l'adresse de la socket */
    adresse.sin_family=AF_INET;
    adresse.sin_addr.s_addr=INADDR_ANY;
    adresse.sin_port=htons(*port);
    statut=bind(s,(struct sockaddr *)&adresse,sizeof(adresse));
    if(statut<0){
        perror("initialisationServeur.bind");
        return -1;
    }
    /* On recupere le numero du port utilise */
    statut=getsockname(s,(struct sockaddr *)&adresse,&taille);
    if(statut<0){
        perror("initialisationServeur.getsockname");
        exit(-1);
    }
    *port=ntohs(adresse.sin_port);
    
    
    /* Taille de la queue d'attente */
    statut=listen(s,connexions);
    if(statut<0){
        perror("initialisationServeur.listen");
        return -1;
    }
    return s;
}


/* Attente de connexion pour renvoyer les client vers la fonction de gestionClient et ainsi répondre aux demandes de connexion le plus rapidement possible */
int boucleServeur_TCP(int ecoute)
{
    int dialogue;
    pthread_t tid;
    initialisation_liste_client();
    while(1){
        
        info_client* client;
        client = (info_client*) malloc(sizeof(info_client));
        /* Attente d'une connexion */
        dialogue=accept(ecoute,(struct sockaddr *) &(client->addr),&(client->len));
#ifdef DEBUG 
            printf("[Serveur] [Lancement_Serveur_TCP.c] [boucleServeur_TCP] Nouveau client vient de se connecter avec les informations suivantes (accept) : IP: '%s' port : '%d'\n", inet_ntoa(client->addr.sin_addr),ntohs(client->addr.sin_port));
#endif         
        if(dialogue<0){
            return -1; //vérifie que la fonction ne renvoie pas d'erreurs et récupère les informations nécessaires du client
        }
        getpeername(dialogue,(struct sockaddr *) &(client->addr),&(client->len));
                         
#ifdef DEBUG 
            printf("[Serveur] [Lancement_Serveur_TCP.c] [boucleServeur_TCP] Nouveau client vient de se connecter avec les informations suivantes (getpeername) : IP: '%s' port : '%d'\n", inet_ntoa(client->addr.sin_addr),ntohs(client->addr.sin_port));
#endif
    
        /*récupère les informations du client afin de les envoyer au thread qui s'en occupera */
        client->socket = dialogue;
        
        
        /* Passage de la socket de dialogue à la fonction de traitement */
        pthread_create(&tid, NULL, gestionClient,(void*) client);
        pthread_detach(tid);
        
    }
}

