

#include "Memorisation_client.h"

/*gère le nombre de clients connectés simultannément afin d'éviter les surcharges et d'empécher la connexion de nouveau client si le serveur est plein */
static int client_connecte;


/*Fonction de hachage pour retrouver le plus facilement et le plus rapidement possible les clients connectés pour traiter les requètes le plus efficacement possible */
int hachage(info_client client){
    int total = 0;
    int i = 0;
    while(client.pseudo[i] != '\0'){
        total += client.pseudo[i];
        total = total % MAX_CLIENT_CONNECTE;
        i++;
    }
    i = 1;
    while(liste_client[total].pseudo[0] != 0 && strcmp(liste_client[total].pseudo, client.pseudo)){
        total += i++;
        total = total%MAX_CLIENT_CONNECTE;
    }
    return total;
}

/*Ajout d'un nouveau client dans notre tableau à condition que la limite de connexion n'est pas atteinte*/
int Connexion_client(info_client client){
    if(client_connecte >= MAX_CLIENT_CONNECTE){
        return -1;
    }
    client_connecte++;
    int i = hachage(client);
    printf("[Sauvegarde_client.c] [Connexion_client] Connexion client '%s' : port: '%d' addr:'%s', socket : '%d'\n",client.pseudo,ntohs(client.addr.sin_port),inet_ntoa(client.addr.sin_addr), client.socket);
    liste_client[i].port = ntohs(client.addr.sin_port);
    strcpy(liste_client[i].hote, inet_ntoa(client.addr.sin_addr));
    strcpy(liste_client[i].pseudo, client.pseudo);
    liste_client[i].socket = client.socket;
    return 0;
}

/*Lancement de cette fonction à la déconnexion des clients afin de libérer la place du tableau que le client occupe */
void Deconnexion_client(info_client client){
    client_connecte--;
    int i = hachage(client);
    printf("[Sauvegarde_client.c] [Connexion_client] Déconnexion client '%s' : port: '%d' addr:'%s'\n",client.pseudo,ntohs(client.addr.sin_port),inet_ntoa(client.addr.sin_addr));
    for(int j =0; j < TAILLE_PSEUDO ; j++){
        liste_client[i].pseudo[j] = 0;
    }
}

/*Permet de savoir combien de clients sont actuellement connectés sur le serveur */
int nombre_de_client_connecte(void){
    return client_connecte;
}
