#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <netinet/in.h>
#include <getopt.h>

       
#include "Lancement_Serveur_TCP.h"
#include "Lancement_Serveur_UDP.h"

#define DEFAULT_PORT 2020
#define MAX_CONNEXIONS 200

static int ecoute;
static int statut;

void recepctrlC(int sig)
{
    printf("\nStatut : %d\n",statut);
    if(statut == 1){
        shutdown(ecoute,SHUT_RDWR);
        force_deconnexion_client_TCP();
        close(ecoute);
        printf("Arret du serveur TCP SIGINT \n");
    }
    if(statut == 2){
        shutdown(ecoute,SHUT_RDWR);
        force_deconnexion_client_UDP();
        close(ecoute);
        printf("Arret du serveur UDP SIGINT \n");
    }
	pthread_exit(0);
}

void Serveur_TCP(short int service){
        
    
    /* Initialisation du serveur */
    ecoute=initialisationServeur_TCP(&service,MAX_CONNEXIONS);
    printf("[Serveur] [main.c] [Serveur_TCP] Lancement du serveur TCP sur le port : %hd avec la socket : %d \n", service, ecoute);
    /* Lancement de la boucle d'ecoute */
    if(ecoute >= 0){
        boucleServeur_TCP(ecoute);
    }
    
	printf("Arret du serveur TCP\n");
    shutdown(ecoute,SHUT_RDWR);
}

void Serveur_UDP(int service){
    
    ecoute = initialisationServeur_UDP(service);
    printf("[main.c] [Serveur_UDP] Lancement du serveur UDP avec la socket numéro %d et sur le port %d\n", ecoute,service);
    boucleServeur_UDP(ecoute);
}

void Mauvais_argument(){
    printf("Les arguments rentrés sont erronés, voici les commandes possibles : \n-t ou --TCP (pour lancer le serveur en TCP)\n-u ou --UDP (pour lancer le serveur en UDP)\n -p <port> --port <port> (pour choisir le port du serveur)\nPar défaut nous sommes sur un serveur UDP sur le port 2020\n");
}

int analyse_syntaxe(int argc, char **argv,short int *service){
    int c;
    int sortie;
    sortie = 2;
    while (1) {
        int option_index = 0;
        static struct option long_options[] = {
            {"port",     required_argument, 0,  'p' },
            {"TCP",     no_argument, 0,  't' },
            {"UDP",     no_argument, 0,  'u' },
        };
        c = getopt_long(argc, argv, "tup:",long_options, &option_index);
        if (c == -1)
            break;
        
        int i = 0;
        short int port = 0;
        switch (c) {
            case 0:
                printf("option %s", long_options[option_index].name);
                if (optarg)
                    printf(" with arg %s", optarg);
                printf("\n");
                break;
                
            case 'p':
                while(optarg[i] >=48 && optarg[i] <=57 ){
                    port =port*10 +( (short int ) optarg[i]-48);
                    i++;
                }
                *service = port;
                break;
            
            case 't':
                sortie = 1;
                break;
                
            case 'u':
                sortie = 2;
                break;
                
            default:
                printf("?? getopt returned character code 0%o ??\n", c);
                sortie = 0;
                Mauvais_argument();
        }
    }
    if (optind < argc) {
        sortie = 0;
        Mauvais_argument();
    }
    return sortie;
}

int main(int argc,char *argv[])
{
    
	struct sigaction action;
	action.sa_handler = recepctrlC;
	sigaction(SIGINT, &action, NULL);
        
    short int service = DEFAULT_PORT;
    
    statut = analyse_syntaxe(argc,argv,&service);
    if(statut == 1){
        Serveur_TCP(service);
    }
    if(statut == 2){
        Serveur_UDP(service);
    }

    return 0;
} 
