#include "Gestion_Client_6.h"

/*Initialisation afin d'éviter tous problèmes avec notre liste de clients connectés */
void initialisation_liste_client(){
    liste_client[MAX_CLIENT_CONNECTE].socket = -1;
    for(int j =0; j < TAILLE_PSEUDO ; j++){
        liste_client[MAX_CLIENT_CONNECTE].pseudo[j] = 0;
    }
}

/* Permet de vérifier si le message du client n'est pas une requête serveur afin de l'envoyer vers la fonction de traitement */
int gestion_requete(char *message, info_client* client, char* protocole){
    char *chaine = NULL;
    
#ifdef DEBUG
    printf("[Serveur] [Gestion_Client_6.c] [gestion_requete] Message recu : '%s'\n",message);
#endif
    
    chaine = strstr(message,"Init_Pseudo!: "); //vérifie que la trame reçue est celle utilisée pour login un client
    if(chaine != NULL){
           
#ifdef DEBUG
    printf("[Serveur] [Gestion_Client_6.c] [gestion_requete] Détection commande login avec le message : '%s'\n",message);
#endif
    
        int i = login(message, client);
        return i;
    }
    int protection = protection_serveur(message, client);
    if(protection == 0){
        
#ifdef DEBUG
    printf("[Serveur] [Gestion_Client_6.c] [gestion_requete] Détection message erroné avec le message : '%s'\n",message);
#endif
    
        return -2;
    }
    chaine = strstr(message,"Co!: "); //vérifie que la trame reçue est celle utilisée pour ce connecter au client B
    if(chaine != NULL){
        
#ifdef DEBUG
    printf("[Serveur] [Gestion_Client_6.c] [gestion_requete] Détection commande de connexion à un autre client avec le message : '%s'\n",message);
#endif
    
        int i = Connexion(message, client, protocole); 
        return i;
    }
    chaine = strstr(message,"Deco!!!"); //vérifie que la trame reçue est celle utilisée pour la déconnexion
    if(chaine != NULL){
        
#ifdef DEBUG
    printf("[Serveur] [Gestion_Client_6.c] [gestion_requete] Détection commande de deconnexion avec le message : '%s'\n",message);
#endif
    
        return -1;
    }
    return 0;
}

int protection_serveur(char* message, info_client* client){
    char* clientA = malloc(sizeof(char)*TAILLE_PSEUDO);
    int i = 0;
    
    while(message[i] != ':' && message[i] != '\0' && message[i] != '\n' && message[i] >=48 && message[i] <= 122){   //Récupération du login que du client A 
        clientA[i] = message[i];
        i++;
    }
    clientA[i] = '\0';
    strcpy(client->pseudo,clientA);
    int j = hachage(*client);
    if(strcmp(liste_client[j].pseudo, clientA) != 0){
        
#ifdef DEBUG
    printf("[Serveur] [Gestion_Client_6.c] [protection_serveur] Pseudo associé au message introuvable dans la base de données, message recu : '%s' pseudo détecté : '%s'\n",message, clientA);
#endif
    free(clientA);
        return 0;
    }
    
#ifdef DEBUG
    printf("[Serveur] [Gestion_Client_6.c] [protection_serveur] Pseudo reconnu, message avant traitement : '%s'\n",message);
#endif
    message = message + i + 1;
    
#ifdef DEBUG
    printf("[Serveur] [Gestion_Client_6.c] [protection_serveur] Message après traitement : '%s'\n",message);
#endif
    
    free(clientA);
    return 1;
}

/*Fonction de traitement lors de l'arrivée d'un nouveau client et de son login */
int login(char* message, info_client* client){
    char *chaine = NULL;
    chaine = strchr(message,' ');
    char* login = malloc(sizeof(char)*TAILLE_PSEUDO);
    int i = 1;
    while(chaine[i] != '\n'){   //Récupération du login que le client a envoyé
        login[i-1] = chaine[i];
        i++;
    }
    login[i-1] = '\0';
    
    printf("[Serveur] [Gestion_Client_6.c] [login] Connexion de '%s'\n",login);

    /* Sauvegarde de toute les informations nécessaires pour pouvoir initier une connexion avec celui ci */
    strcpy(client->pseudo,login);
    free(login);    
    if(Connexion_client(*client) != 0){
        printf("[Serveur] [Gestion_Client_6.c] [login] Le serveur est plein \n");
        return -1;
    }
    return 1;
}

int Connexion(char* message,info_client* client,char* protocole){
    char *chaine = NULL;
    int i = 0;
    chaine = strchr(message,' ');
    char* clientB = malloc(sizeof(char)*TAILLE_PSEUDO);
    char* clientA = malloc(sizeof(char)*TAILLE_PSEUDO);
    while(message[i] != ':'){   //Récupération du login du client A 
        clientA[i] = message[i];
        i++;
    }
    i = 1;
    while(chaine[i] != '\n'){   //Récupération du login que le client A a envoyé
        clientB[i-1] = chaine[i];
        i++;
    }
    clientB[i-1] = '\0';
    
    printf("[Serveur] [Gestion_Client_6.c] [Connexion] Connexion de '%s' à '%s'\n",clientA,clientB);
    /* Sauvegarde de toute les informations nécessaires pour pouvoir initier une connexion avec celui ci */

    Initiation_hole_punching(clientA,clientB,protocole);
    free(clientB);
    free(clientA);
    
    return 1;
}

void Initiation_hole_punching(char* client_A, char* client_B, char* protocole){

#ifdef DEBUG
    printf("[Serveur] [Gestion_Client_6.c] [Initiation_hole_punching] Initiation du hole punching entre les clients '%s' et '%s' en '%s'\n",client_A,client_B,protocole);
#endif
    
    struct sockaddr_in6 ClientA;
    struct sockaddr_in6 ClientB;
    socklen_t lenA = sizeof(ClientA);
    socklen_t lenB = sizeof(ClientB);
    
    info_client Cb;
    info_client Ca;
    strcpy(Ca.pseudo,client_A);
    strcpy(Cb.pseudo,client_B);
    int a = hachage(Ca);
    int b = hachage(Cb);
    
    ClientA.sin6_family = AF_INET6;
    ClientA.sin6_port = htons(liste_client[a].port);
    inet_pton(AF_INET6, liste_client[a].hote, &ClientA.sin6_addr);
    ClientB.sin6_family = AF_INET6;
    ClientB.sin6_port = htons(liste_client[b].port);
    inet_pton(AF_INET6, liste_client[b].hote, &ClientB.sin6_addr);
    char* message = (char*) malloc(sizeof(char)*MAX_LIGNE);
    int n = sprintf(message,"Connexion_a!: %s\nIP!: %s\nport!: %d\n",client_A,liste_client[a].hote,liste_client[a].port);
    message[n] = '\0';
    int statut = sendto(liste_client[b].socket,message,MAX_LIGNE, 0, (struct sockaddr *) &ClientB, lenB);
    if(statut < 0){
        printf("socket : %d\n",liste_client[b].socket);
        perror("Initiation_hole_punching.sendto");
    }
    
#ifdef DEBUG
        printf("[Serveur] [Gestion_Client_6.c] [Initiation_hole_punching] Message envoyé à '%s' : '%s'\n",client_B, message);
#endif
        
    free(message);
    char* message_2 = (char*) malloc(sizeof(char)*MAX_LIGNE);
    n = sprintf(message_2,"Connexion_a!: %s\nIP!: %s\nport!: %d\n",client_B,liste_client[b].hote,liste_client[b].port);
    message_2[n] = '\0';
    statut = sendto(liste_client[a].socket,message_2,MAX_LIGNE, 0, (struct sockaddr *) &ClientA , lenA);
    if(statut < 0){
        printf("socket : %d\n",liste_client[a].socket);
        perror("Initiation_hole_punching.sendto");
    }
    
#ifdef DEBUG
        printf("[Serveur] [Gestion_Client_6.c] [Initiation_hole_punching] Message envoyé à '%s' : '%s'\n",client_A, message_2);
#endif
        

}


void force_deconnexion_client_UDP(void){
    if( nombre_de_client_connecte() > 0){
        for(int i = 0;i < MAX_CLIENT_CONNECTE ; i++){
            if(liste_client[i].pseudo[0] != 0){
                
                struct sockaddr_in6 Client;
                socklen_t len = sizeof(Client);
                Client.sin6_family = AF_INET6;
                Client.sin6_port = htons(liste_client[i].port);
                inet_pton(AF_INET6, liste_client[i].hote, &Client.sin6_addr);
                char message[MAX_LIGNE] = "DeconnexionServeur!!!\n";
                char str[INET6_ADDRSTRLEN];
                inet_ntop(AF_INET6, &(Client.sin6_addr), str, INET6_ADDRSTRLEN);            
#ifdef DEBUG
                printf("[Serveur] [Gestion_Client_6.c] [force_deconnexion_client_UDP] Force la déconnexion de : '%s' qui a pour IP: '%s' et port : '%d' avec le message : '%s'\n",liste_client[i].pseudo , str , ntohs(Client.sin6_port) , message);
#endif
        
                sendto(liste_client[i].socket, message, MAX_LIGNE,0,(struct sockaddr *)&Client,len);
            }
        }
    }
}
