#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>       
#include <netdb.h>


#include "Lancement_Serveur_UDP_6.h"


int initialisationServeur_UDP(int port){
    int s; 
    struct sockaddr_in6 addr;
    
    s = socket( PF_INET6, SOCK_DGRAM, 0 );

    addr.sin6_family = AF_INET6;
    addr.sin6_addr = in6addr_any;
    addr.sin6_port = htons ((unsigned short)port);
    addr.sin6_flowinfo=0;
    addr.sin6_scope_id=0;
    
    int vrai=1;
    if(setsockopt(s,SOL_SOCKET,SO_REUSEADDR,&vrai,sizeof(vrai))<0){
        perror("initialisationServeurUDPgenerique.setsockopt (REUSEADDR)");
        exit(-1);
    }
    
    if ( bind( s, (struct sockaddr *)&addr, sizeof(addr)) < 0 )
    {
        perror("initialisationServeurUDP.bind"); 
        exit(-1);
    }
    return s;
}

int traitement_message_UDP(unsigned char* msg, int nboctets,info_client *client){
    
    #ifdef DEBUG
    printf("[Serveur] [Lancement_Serveur_UDP_6.c] [traitement_message_UDP] Message recu avant gestion_requete: '%s'\n", msg);
    #endif
    
    int statut = gestion_requete((char*) msg,client, "UDP");
    if(statut == 0){
        printf("Message recu : ");
        for(int i = 0; i<nboctets ; i++){
            printf("%c",msg[i]);
        }
    }
    if(statut == -2){
        printf("Message indésirable recu : ");
        for(int i = 0; i<nboctets ; i++){
            printf("%c",msg[i]);
        }
    }
    return statut;
}

int boucleServeur_UDP(int s){
    struct sockaddr_in6 their_addr; /* Adresse du connecté */
    unsigned int addr_len = sizeof(their_addr);
    char *str=malloc(sizeof(char)*INET6_ADDRSTRLEN);
    
    while(1){
        memset(&their_addr,0,sizeof(struct sockaddr_in6));
        unsigned char* message = (unsigned char*) malloc(sizeof(unsigned char)*MAX_UDP_MESSAGE);
        info_client* client;
        client = (info_client*) malloc(sizeof(info_client));
        int nboctets=recvfrom(s,message,MAX_UDP_MESSAGE,0,(struct sockaddr *)&their_addr, &addr_len);
        memset(str,0,sizeof(char)*INET6_ADDRSTRLEN);
        inet_ntop(AF_INET6, &(client->addr.sin6_addr), str, sizeof(char)*INET6_ADDRSTRLEN);
        #ifdef DEBUG 
        printf("[Serveur] [Lancement_Serveur_UDP_6.c] [boucleServeur_UDP] Message recu du client : '%s' ayant l'IP : '%s' et le port : '%d'\n", message, str, ntohs(their_addr.sin6_port));
        #endif
        client->addr = their_addr;
        client->len = addr_len;
        client->socket = s;
        if(nboctets<0) return -1;
        message[nboctets] = '\0';
        int reponse_traitement = traitement_message_UDP(message,nboctets+1,client);
        if( reponse_traitement == -2){
            char* message_erreur = malloc(sizeof(char)*MAX_UDP_MESSAGE);
            strcpy(message_erreur,"Veuillez utiliser notre Client pour communiquer avec notre serveur\n");
            
            #ifdef DEBUG 
            printf("[Serveur] [Lancement_Serveur_UDP_6.c] [boucleServeur_UDP] Message envoyé en réponse au client : '%s'\n", message_erreur);
            #endif
            
            sendto(s,message_erreur ,strlen(message_erreur),0,(struct sockaddr *)&their_addr, addr_len) ;
            free(message_erreur);
        }
        if( reponse_traitement == -1){
            Deconnexion_client(*client);
        }
        free(message);
        free(client);
    }
    free(str);
    return 0;
}

