

#include "Memorisation_client_6.h"

/*gère le nombre de clients connectés simultannément afin d'éviter les surcharges et déconnecter les clients si le serveur est plein */
static int client_connecte;


/*Fonction de hachage pour retrouver le plus facilement et le plus rapidement possible les clients connectés pour traiter les requêtes le plus efficacement possible */
int hachage(info_client client){
    int total = 0;
    int i = 0;
    while(client.pseudo[i] != '\0'){
        total += client.pseudo[i];
        total = total % MAX_CLIENT_CONNECTE;
        i++;
    }
    i = 1;
    while(liste_client[total].pseudo[0] != 0 && strcmp(liste_client[total].pseudo, client.pseudo)){
        total += i++;
        total = total%MAX_CLIENT_CONNECTE;
    }
    return total;
}


int Connexion_client(info_client client){
    if(client_connecte >= MAX_CLIENT_CONNECTE){
        return -1;
    }
    client_connecte++;
    int i = hachage(client);
    char str[INET6_ADDRSTRLEN];
    inet_ntop(AF_INET6, &(client.addr.sin6_addr), str, INET6_ADDRSTRLEN);
    printf("[Sauvegarde_client_6.c] [Connexion_client] Connexion client '%s' : port: '%d' addr:'%s', socket : '%d'\n",client.pseudo,ntohs(client.addr.sin6_port),str, client.socket);
    liste_client[i].port = ntohs(client.addr.sin6_port);
    strcpy(liste_client[i].hote, str);
    strcpy(liste_client[i].pseudo, client.pseudo);
    liste_client[i].socket = client.socket;
    return 0;
}

/*Lancement de cette fonction à la déconnexion des clients afin de libérer la place du tableau que le client occupe */
void Deconnexion_client(info_client client){
    client_connecte--;
    int i = hachage(client);
    char str[INET6_ADDRSTRLEN];
    inet_ntop(AF_INET6, &(client.addr.sin6_addr), str, INET6_ADDRSTRLEN);
    printf("[Sauvegarde_client_6.c] [Connexion_client] Deconnexion client '%s' : port: '%d' addr:'%s'\n",client.pseudo,ntohs(client.addr.sin6_port),str);
    for(int j =0; j < TAILLE_PSEUDO ; j++){
        liste_client[i].pseudo[j] = 0;
    }
}

/*Permet de savoir combien de clients sont actuellement connectés sur le serveur */
int nombre_de_client_connecte(void){
    return client_connecte;
}
